#ifndef _MELEE_H
#include "melee.h"
#endif

#ifndef _MCBODIES_H
#define _MCBODIES_H

typedef struct {
  SpaceSprite *s;
  double      x[MAX_STARS];
  double      y[MAX_STARS];
} STAR_DATA;

class Stars {
  STAR_DATA sd[3];

  public:
  Stars();
  ~Stars();

  void animate(Frame *space);
};

class Asteroid : public SpaceObject {
  protected:
  int step;
  int speed;

  public:
  Asteroid();

  virtual void calculate();
  virtual void handle_damage();
};

class Planet : public SpaceObject {
  public:
  Planet(SpaceSprite *osprite);

  virtual void inflict_damage(SpaceObject *other);
};

extern Planet *spacePlanet;

#endif