#include <string.h>

#include "../melee.h"

#include "mcontrol.h"
#include "mnet.h"
#include "mai.h"


extern char dialog_string[20][80];


const char num_controls = 6;
static char *gcc_sucks_dick[num_controls + 1] = 
		{"None", "Keyboard", "Joystick", "MoronBot", "WussieBot", "SpyAI", NULL};
char **control_name = gcc_sucks_dick;


Control *getController(int type, char *name) {
	switch (type) {
		case 1: return new ControlKB(name);
		case 2: return new ControlJoy(name);
		case 3: return new ControlMoron(name);
		case 4: return new ControlWussie(name);
		case 5: return new ControlSpyAI(name);
		}
	return NULL;
	}
int control2number(char *name) {
	if (!name) return -1;
	for (int i = 0; i < num_controls; i += 1) {
		if (!strcmp(name, control_name[i])) return i;
		}
	return -1;
	}


void Control::setup() {}
void Control::select_ship(Ship* ship_pointer, char* ship_name) {
	ship = ship_pointer;
	if (ship && num_targets) ship->target = target[active_target];
	return;
	}
void Control::load(char* inifile, char* inisection) {
	return;
	}
void Control::save(char* inifile, char* inisection) {
	return;
	}
void Control::calculate() {
	int i;
	for (i = 0; i < num_targets; i += 1) {
		if (!target[i]->exists()) {
			remove_target(target[i]);
			i -= 1;
			}
		}
	if (!ship) return;
	if (!ship->exists()) {
		select_ship( NULL, NULL);
		return;
		}
	i = ship->nextkeys;
	ship->nextkeys = think();
	ship->thrust       = 1&&(i & keyflag::thrust);
	ship->turn_left    = 1&&(i & keyflag::left);
	ship->turn_right   = 1&&(i & keyflag::right);
	ship->fire_weapon  = 1&&(i & keyflag::fire);
	ship->fire_special = 1&&(i & keyflag::special);
	ship->target_next = 1&&(i & keyflag::next);
	ship->target_prev = 1&&(i & keyflag::prev);
	ship->target_close = 1&&(i & keyflag::close);
	if (ship->target_next) debug_value += 1000;
	return;
	}
char Control::think() {
	return 0;
	}
char *Control::getDescription() {
	return iname;
	}
void Control::initialize() {
	return;
	}
void Control::deinitialize() {
	select_ship ( NULL, NULL );
	return;
	}
Control::Control(char *name) : ship(NULL), num_targets(0), target(NULL), 
		active_target(-1) {
	iname = strdup(name);
	}
void Control::add_target(Ship *killit) {
	if (!killit) return;
	if (!killit->exists()) return;
	for (int i = 0; i < num_targets; i += 1) {
		if (target[i] == killit) return;
		}
	num_targets += 1;
	target = (Ship**) realloc(target, sizeof(Ship *) * num_targets);
	target[num_targets-1] = killit;
	if (active_target == -1) set_target(0);
	return;
	}
void Control::remove_target(Ship *killit) {
	if (!killit) return;
	for (int i = 0; i < num_targets; i += 1) {
		if (target[i] == killit) {
			num_targets -= 1;
			target[i] = target[num_targets];
			target = (Ship**)realloc(target, num_targets * sizeof(Ship *));
			if (active_target == i) {
				if (num_targets) set_target(random() % num_targets);
				else set_target(-1);
				return;
				}
			}
		}
	return;
	}
void Control::set_target(int i) {
	if (i >= num_targets) return;
	active_target = i;
	if (ship) {
		if (i >= 0) ship->target = target[i];
		else ship->target = NULL;
		}
	return;
	}


void ControlKB::load (char *inifile, char *inisection) {
	set_config_file (inifile);
  thrust  = key_num(get_config_string(inisection, "Keyboard_Thrust", 0));
  left    = key_num(get_config_string(inisection, "Keyboard_Left", 0));
  right   = key_num(get_config_string(inisection, "Keyboard_Right", 0));
  fire    = key_num(get_config_string(inisection, "Keyboard_Fire", 0));
  special = key_num(get_config_string(inisection, "Keyboard_Special", 0));
  next = key_num(get_config_string(inisection, "Keyboard_Next_Target", 0));
  prev = key_num(get_config_string(inisection, "Keyboard_Prev_Target", 0));
  close = key_num(get_config_string(inisection, "Keyboard_Close_Target", 0));
	return;
	}
void ControlKB::save (char *inifile, char *inisection) {
	set_config_file (inifile);
	set_config_string(inisection, "Keyboard_Thrust", key_string[thrust]);
	set_config_string(inisection, "Keyboard_Left", key_string[left]);
	set_config_string(inisection, "Keyboard_Right", key_string[right]);
	set_config_string(inisection, "Keyboard_Fire", key_string[fire]);
	set_config_string(inisection, "Keyboard_Special", key_string[special]);
  set_config_string(inisection, "Keyboard_Next_Target", key_string[next]);
  set_config_string(inisection, "Keyboard_Prev_Target", key_string[prev]);
  set_config_string(inisection, "Keyboard_Close_Target", key_string[close]);
	return;
	}
char *ControlKB::getTypeName() {
	return "Keyboard_Controller";
	}
char ControlKB::think() {
  int r = 0;
  if (key[thrust]) r |= keyflag::thrust;
  if (key[left]) r |= keyflag::left;
  if (key[right]) r |= keyflag::right;
  if (key[fire]) r |= keyflag::fire;
  if (key[special]) r |= keyflag::special;
  if (key[next]) r |= keyflag::next;
  if (key[prev]) r |= keyflag::prev;
  if (key[close]) r |= keyflag::close;
  return r;
	}
ControlKB::ControlKB(char *name) : Control(name) {}

#define KEY_DIALOG_MODIFY 0
#define KEY_DIALOG_OK     1
#define KEY_DIALOG_CANCEL 2
DIALOG keyDialog[] = {
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp)
  { d_textbox_proc,    40,   20,   120,  32,   255,  0,    0,    0,       0,    0,    dialog_string[0], NULL, NULL },
  { d_button_proc,     40,   150,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    dialog_string[1], NULL, NULL },
  { d_button_proc,     440,  150,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    dialog_string[2], NULL, NULL },
  { d_button_proc,     240,  80,   160,  48,   255,  0,    0,    D_EXIT,  0,    0,    dialog_string[3], NULL, NULL },
  { d_button_proc,     240,  150,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    dialog_string[4], NULL, NULL },
  { d_button_proc,     240,  230,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    dialog_string[5], NULL, NULL },
  { d_button_proc,     40,   300,  160,  40,   255,  0,    0,    D_EXIT,  0,    0,    dialog_string[6], NULL, NULL },
  { d_button_proc,     240,  300,  160,  40,   255,  0,    0,    D_EXIT,  0,    0,    dialog_string[7], NULL, NULL },
  { d_button_proc,     440,  300,  160,  40,   255,  0,    0,    D_EXIT,  0,    0,    dialog_string[8], NULL, NULL },
  { d_button_proc,     140,  370,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void*)"Accept Changes", NULL, NULL },
  { d_button_proc,     340,  370,  160,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void*)"Cancel", NULL, NULL },
  { NULL,              0,    0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
};

void ControlKB::setup() {
  int i, t = 0;
  set_dialog_color(keyDialog, makecol(0,0,0), makecol(255,255,255));
	load("scp.ini", getDescription());
  while (true) {
    sprintf ( dialog_string[0], "Keyboard %s:\nSet Your Keys", getDescription());
		sprintf ( dialog_string[1], "Left: %s", key_string[left]);
		sprintf ( dialog_string[2], "Right: %s", key_string[right]);
		sprintf ( dialog_string[3], "Thrust: %s", key_string[thrust]);
		sprintf ( dialog_string[4], "Fire: %s", key_string[fire]);
		sprintf ( dialog_string[5], "Special: %s", key_string[special]);
		sprintf ( dialog_string[6], "Next Target: %s", key_string[next]);
		sprintf ( dialog_string[7], "Prev Target: %s", key_string[prev]);
		sprintf ( dialog_string[8], "Close Target: %s", key_string[close]);
    i = popup_dialog(keyDialog, 1);
		if (i == -1) return;
    if (i <= 8) {
      t = readkey() >> 8;
    }
    if (t == KEY_ESC) i = 7;
    switch (i) {
      case 1: left = t;    break;
      case 2: right = t;   break;
      case 3: thrust = t;  break;
      case 4: fire = t;    break;
      case 5: special = t; break;
      case 6: next = t; break;
      case 7: prev = t; break;
      case 8: close = t; break;
      case 9:  save("scp.ini", getDescription()); return;
      case 10: load("scp.ini", getDescription()); return;
      }
    }
  }


char *ControlMoron::getTypeName() {
	return "MoronBot";
	}
char stupid_bot(Ship *ship) {
	int r = 0;
	double a;
	if (!ship->target) return 0;
	if (!ship->target->exists()) {
		ship->target = NULL;
		return 0;
		}
	a = ship->trajectory_angle(ship->target) - ship->get_angle();
	a = fmod(a + 360, 360);
  if (a < 180) {
    r |= keyflag::right;
    }
  else {
    r |= keyflag::left;
    return r;
    }
  a = int(ship->distance(ship->target));
  if (a > 2000) {
    r |= keyflag::thrust;
    }
  else {
    r |= keyflag::thrust;
    r |= keyflag::fire;
    }
  return r;
	}
char ControlMoron::think() {
	return stupid_bot(ship);
	}
ControlMoron::ControlMoron(char *name) : Control(name) {}



char *ControlJoy::getTypeName() {
	return "Joystick Contoller";
	}
void ControlJoy::initialize() {
	install_joystick(JOY_TYPE_AUTODETECT);
	return;
	}
void ControlJoy::deinitialize() {
	Control::deinitialize();
	remove_joystick();
	return;
	}
char ControlJoy::think() {
	int r = 0;
	if (num_joysticks <= which_joystick) {
		char buffy[80];
		sprintf (buffy, "Joystick %d requested, only %d detected", which_joystick, num_joysticks);
		tw_error(buffy);
		}
	if (joy[which_joystick].button[0].b) r |= keyflag::fire;
	if (joy[which_joystick].button[1].b) r |= keyflag::special;
	if (joy[which_joystick].stick[0].axis[0].d2) r |= keyflag::left;
	if (joy[which_joystick].stick[0].axis[0].d1) r |= keyflag::right;
	if (joy[which_joystick].stick[0].axis[1].d2) r |= keyflag::thrust;	
  return r;
	}
ControlJoy::ControlJoy(char *name) : Control(name), which_joystick(0) {
	return;
	}


void ControlSpyAI::select_ship(Ship* ship_pointer, char* ship_name) {
//	if (ai) delete ai;
	ai = init_ai(ship_pointer, ship_name);
	Control::select_ship(ship_pointer, ship_name);
	return;
	}
char ControlSpyAI::think() {
	if (ai) {
		ai->calculate();
		return ai->k.convert();
		}
	return stupid_bot(ship);
	}
void ControlSpyAI::deinitialize() {
	Control::deinitialize();
	return;
	}
ControlSpyAI::ControlSpyAI(char *name) : Control(name) {
	ai = NULL;
	return;
	}
char *ControlSpyAI::getTypeName() {
	return "SpyAI";
	}



	
/*

static int buflen;
static int buffy[256];
static int pos = 0;
static int net = 0;

void ControlKB::initialize(char* init_string) {
  loadKeys();
  ai = NULL;
	if (play_mode == 2) type += 12;
	if (play_mode == 3) type += 24;
	for (int i = 0; i < buflen; i += 1) {
		buffy[i] = 0;
		if (type >= 24) {
			while (!net_pending(2)) ;
			net_send(0);
			}
		}
	rest (buflen * 20);
	pos = 0;
	}

void ControlKB::deinitialize() {
  desc[0] = '\0'; // Clear it, more or less;
  if (ai) delete ai;
  ai = NULL;
}


void ControlKB::act(int a, int n) {
  int i;
	if (n == 2) {
		while (!net_pending(2)) ;
		net_send(a);
		int tmp = buffy[pos];
		buffy[pos] = a;
		a = tmp;
		pos = (pos + 1) % buflen;
		}
	if (n == 1) {
		while (!net_pending()) ;
		a = net_recv();
		}
  i = my_ship->nextkeys;
	if (i == 0xff) i = a;
  my_ship->nextkeys = a;
  my_ship->thrust       = 1&&(i & keyflag::thrust);
  my_ship->turn_left    = 1&&(i & keyflag::left);
  my_ship->turn_right   = 1&&(i & keyflag::right);
  my_ship->fire_weapon  = 1&&(i & keyflag::fire);
  my_ship->fire_special = 1&&(i & keyflag::special);
  return;
  }

void ControlKB::calculate() {
  unsigned int action = 0;
//  if (!my_ship->target->exists()) my_ship->target = NULL;
  switch (type % 3) {
    case 2:
      if (ai) {
        ai->calculate();
        action = ai->k.convert();
        }
      else {
				action = bot();
			}
      break;
    case 1:
      action = bot();
      break;
    case 0:
      action = human();
      break;
    }
  act(action, type / 12);
	if (key[KEY_1]) while (!key[KEY_ESC]) ;
  return;
}

*/