
#ifndef _MMAIN_H
#define _MMAIN_H

extern int debug_value;

extern int hero;
extern int num_players;
extern Control **control;
extern ShipPanel **panel;

extern char fleet_title[];
extern int  fleet_cost;

extern DATAFILE *melee;
extern DATAFILE *scppal;

#define GRAVITY_FORCE 2000.0
#define GRAVITY_RANGE 1000.0

extern int antia_on;

void init_fleet();
void select_fleet_slot(int slot, int ship_index);
void clear_fleet_slot(int slot);
void save_fleet(char *filename, char *section);
void load_fleet(char *filename, char *section);

void play_melee( int play_mode, int num_players, Control **players);

#endif