#include "../melee.h"

#include "mview.h"
#include "mmain.h"
#include "mcbodies.h"


View *view = NULL;
int view_num = -1;

const char num_views = 5;
static char *gcc_sucks_dick[num_views + 1] = 
		{"Planet", "Hero", "Looking", "Enemy", "Enemy_Discrete", NULL};
char **view_name = gcc_sucks_dick;

void set_view (int type) {
	if (type == -1) type = 0;
	if (type == view_num) return;
	else free(view);
	view_num = type;
	switch (type) {
		case 0:
			view = new View_Planet();
			break;
		case 1:
			view = new View_Hero();
			break;
		case 2:
			view = new View_Looking();
			break;
		case 3:
			view = new View_Enemy();
			break;
		case 4:
			view = new View_Enemy_Discrete();
			break;
		}
	view->init();
	return;
	}
int view2number(char *name) {
	if (!name) return -1;
	for (int i = 0; i < num_views; i += 1) {
		if (!strcmp(name, view_name[i])) return i;
		}
	return -1;
	}



double space_x = 0, space_y = 0;
double space_zoom = 0.25;
double space_x_stars = 0, space_y_stars = 0;
static double odx = 0, ody = 0;
void set_view (double x, double y, double zoom) {
  double dx, dy;
  space_x += VIEW_X / 2 / space_zoom;
  space_y += VIEW_Y / 2 / space_zoom;
  dx = min_delta( space_x, x, X_MAX);
  dy = min_delta( space_y, y, Y_MAX);
	double t = fabs(dx - odx) + fabs(dy - ody);
	odx = dx;
	ody = dy;
	if (t < 100) {
		double r = sqrt (dx * dx + dy * dy);
		if (r > 3) {
			r = 3 * sqrt(r / 3);
			dx = dx / r;
			dy = dy / r;
			}
		}
  space_x -= dx;
  space_y -= dy;
	space_x_stars -= dx;
	space_y_stars -= dy;
  space_zoom = zoom;
	if (space_zoom > 1) space_zoom = 1;
  space_x -= VIEW_X / 2 / space_zoom;
  space_y -= VIEW_Y / 2 / space_zoom;
	while (space_x > X_MAX) space_x -= X_MAX;
	while (space_x < 0) space_x += X_MAX;
	while (space_y > Y_MAX) space_y -= Y_MAX;
	while (space_y < 0) space_y += Y_MAX;
	while (space_x_stars >  X_MAX * 16) space_x_stars -= X_MAX * 16;
	while (space_x_stars < -X_MAX *  0) space_x_stars += X_MAX * 16;
	while (space_y_stars >  Y_MAX * 16) space_y_stars -= Y_MAX * 16;
	while (space_y_stars < -Y_MAX *  0) space_y_stars += Y_MAX * 16;
  }


void View::init() {}
void View::view() {}




void View_Planet::view () {
	set_view(spacePlanet->normal_x(), spacePlanet->normal_y(), 0.125);
	return;
	}



void View_Hero::init() {
	z = 0.5; 
	x = 0; 
	y = 0;
	return;
	}
void View_Hero::view() {
	if (key[KEY_EQUALS]) z *= 1.01;
	if (key[KEY_MINUS]) z /= 1.01;
	if (z < 0.25) z = 0.25;
	if (z > 1) z = 1;
	if (panel[hero] && panel[hero]->ship && panel[hero]->ship->exists()) {
		x = panel[hero]->ship->normal_x();
		y = panel[hero]->ship->normal_y();
		}
	set_view(x, y, z);
	return;
	}



void View_Looking::init() {
	z = 0.5; x = 0; y = 0;
	return;
	}
void View_Looking::view() {
	if (key[KEY_EQUALS]) z *= 1.01;
	if (key[KEY_MINUS]) z /= 1.01;
	if (z < 0.25) z = 0.25;
	if (z > 1) z = 1;
	if (panel[hero] && panel[hero]->ship && panel[hero]->ship->exists()) {
		x = panel[hero]->ship->normal_x();
		y = panel[hero]->ship->normal_y();
		x += VIEW_X / z * cos(panel[hero]->ship->get_angle() * ANGLE_RATIO) / 6;
		y += VIEW_Y / z * sin(panel[hero]->ship->get_angle() * ANGLE_RATIO) / 6;
		}
	set_view(x, y, z);
	return;
	}



void View_Enemy::init() {
	x = y = 0;
	return;
	}
void View_Enemy::view() {
	if (panel[hero] && panel[hero]->ship && panel[hero]->ship->exists()) {
		x = panel[hero]->ship->normal_x();
		y = panel[hero]->ship->normal_y();
		z = 1;
		if (panel[hero] && panel[hero]->ship->target && panel[hero]->ship->target->exists()) {
			double x2, y2, z2;
			x2 = panel[hero]->ship->nearest_x(panel[hero]->ship->target) - x;
			y2 = panel[hero]->ship->nearest_y(panel[hero]->ship->target) - y;
			z2 = VIEW_X / 1.1 / (fabs(x2) + 1);
			if (z > z2) z = z2;
			z2 = VIEW_Y / 1.1 / (fabs(y2) + 1);
			if (z > z2) z = z2;
			x = normalize(x + x2 / 2, X_MAX);
			y = normalize(y + y2 / 2, Y_MAX);
			}
		}
	set_view(x, y, z);
	return;
	}



void View_Enemy_Discrete::init() {
	x = y = 0;
	return;
	}
void View_Enemy_Discrete::view() {
	if (panel[hero]->ship && panel[hero]->ship->exists()) {
		x = panel[hero]->ship->normal_x();
		y = panel[hero]->ship->normal_y();
		z = 1;
		if (panel[hero] && panel[hero]->ship->target) {
			double x2, y2, z2;
			x2 = panel[hero]->ship->nearest_x(panel[hero]->ship->target) - x;
			y2 = panel[hero]->ship->nearest_y(panel[hero]->ship->target) - y;
			z2 = VIEW_X / 1.1 / (fabs(x2) + 1);
			if (z > z2) z = z2;
			z2 = VIEW_Y / 1.1 / (fabs(y2) + 1);
			if (z > z2) z = z2;
			x = normalize(x + x2 / 2, X_MAX);
			y = normalize(y + y2 / 2, Y_MAX);
			}
		}
	if (z < 0.5) z = 0.25;
	else if (z < 1) z = 0.5;
	set_view(x, y, z);
	return;
	}

