#ifndef _ID_H
#define _ID_H

#define SPACE_LOCATION 0x0000

#define SPACE_MASK     0x00FF

#define SPACE_OBJECT   0x0010
#define SPACE_PLANET   0x0011
#define SPACE_ASTEROID 0x0012
#define SPACE_SHIP     0x0013
#define SPACE_SHOT     0x0014

// Ship ID masks
#define ANDROSYNTH_SHIP 0x0100
#define ARILOU_SHIP     0x0200
#define CHENJESU_SHIP   0x0300
#define CHMMR_SHIP      0x0400
#define DRUUGE_SHIP     0x0500
#define EARTHLING_SHIP  0x0600
#define ILWRATH_SHIP    0x0700
#define KOHRAH_SHIP     0x0800
#define KZERZA_SHIP     0x0900
#define MELNORME_SHIP   0x0A00
#define MMRNMHRMX_SHIP  0x0B00
#define MMRNMHRMY_SHIP  0x0C00
#define MYCON_SHIP      0x0D00
#define ORZ_SHIP        0x0E00
#define PKUNK_SHIP      0x0F00
#define SHOFIXTI_SHIP   0x1000
#define SLYLANDRO_SHIP  0x1100
#define SPATHI_SHIP     0x1200
#define SUPOX_SHIP      0x1300
#define SYREEN_SHIP     0x1400
#define THRADDASH_SHIP  0x1500
#define UMGAH_SHIP      0x1600
#define UTWIG_SHIP      0x1700
#define VUX_SHIP        0x1800
#define YEHAT_SHIP      0x1900
#define ZOQFOTPIK_SHIP  0x1A00

// Shot ID masks
#define ANDROSYNTH_SHOT  0x1000
#define CHENJESU_SHOT    0x1100
#define DRUUGE_SHOT      0x1200
#define EARTHLING_SHOT   0x1300
#define KOHRAHBLADE_SHOT 0x1400
#define KOHRAHFRIED_SHOT 0x1500
#define KZERZA_SHOT      0x1600
#define MELNORME_SHOT    0x1700
#define MELNORMEDIS_SHOT 0x1800
#define MYCON_SHOT       0x1900
#define ORZ_SHOT         0x1A00
#define THRADDASH_SHOT   0x1B00
#define THRADFLAME_SHOT  0x1C00
#define ZOQFOTPIK_SHOT   0x1D00

// Special masks
#define CHENDOGI_SPEC    0x3100
#define CHMMR_SPEC       0x3000
#define KZERZAFIGHT_SPEC 0x3200
#define ORZMARINE_SPEC   0x3300
#define SYREENCREW_SPEC  0x3400
#define VUXLIMPET_SPEC   0x3500


#define SPACE_LINE     0x0020
#define SPACE_LASER    0x0021

// Laser ID masks
#define ARILOU_LASER     0x2000
#define CHMMR_LASER      0x2100
#define SLYLANDRO_LASER  0x2200

#endif