#ifndef _MELEE_H
#include "../melee.h"
#endif

#ifndef _MVIEW_H
#define _MVIEW_H

extern View *view;
extern int view_num;

extern const char num_views;
extern char **view_name;
void set_view (int type) ;
int view2number(char *name) ;

extern double space_x, space_y;
extern double space_zoom;
extern double space_x_stars, space_y_stars;

class View {
	public:
	virtual void view();
	virtual void init();
	};

class View_Planet : public View {
	public:
	virtual void view();
	};

class View_Hero : public View {
	double x, y, z;
	public:
	virtual void view();
	virtual void init();
	};

class View_Looking : public View {
	double x, y, z;
	public:
	virtual void view();
	virtual void init();
	};

class View_Enemy : public View {
	double x, y, z;
	public:
	virtual void view();
	virtual void init();
	};

class View_Enemy_Discrete : public View {
	double x, y, z;
	public:
	virtual void view();
	virtual void init();
	};

#endif